| ovrnainverse

## Wiki

The master copies of EMBOSS documentation are available at http://emboss.open-bio.org/wiki/Appdocs on the EMBOSS Wiki.

Please help by correcting and extending the Wiki pages.

## Function

Find RNA sequences with a given secondary structure

## Description

This is a port of the Vienna RNA package program RNAinverse.

It searches for sequences folding into a predefined structure, thereby inverting the folding algorithm. Target structures (in bracket notation) and starting sequences for the search are read.

## Algorithm

Characters in the start sequence other than "AUGC" (or the alphabet specified with -a) are treated as wild cards and replaced by a random character. Any lower case characters in the start sequence are kept fixed during the search. If necessary, the sequence will be elongated to the length of the structure. Thus a string of "N"s as well as a blank line specify a random start sequence.

For each search the best sequence found and its Hamming distance to the start sequence are output. If the the search was unsuccessful, a structure distance to the target is appended. Optionally the output format can be modified.

The program will continue to read new structures and sequences until a line consisting of the single character "@" or an end of file condition is encountered.

See the original documentation for the Vienna RNA package http://www.tbi.univie.ac.at/~ivo/RNA/

## Usage

Here is a sample session with ovrnainverse

    % ovrnainverse -repeats 3
    Find RNA sequences with a given secondary structure
    Vienna RNA structures file: rna3.fold
    Vienna RNAfold output file [rna3.ovrnainverse]:

Go to the input files for this example
Go to the output files for this example

Example 2

    % ovrnainverse -repeats 3 -succeed
    Find RNA sequences with a given secondary structure
    Vienna RNA structures file: rna3.fold
    Vienna RNAfold output file [rna3.ovrnainverse]:

Go to the output files for this example

## Command line arguments

    Find RNA sequences with a given secondary structure
    Version: EMBOSS:6.6.0.0

       Standard (Mandatory) qualifiers:
      [-structuresfile]    infile     Vienna RNA structures file
      [-outfile]           outfile    [*.ovrnainverse] Vienna RNAfold output file

       Additional (Optional) qualifiers: (none)
       Advanced (Unprompted) qualifiers:
       -sequence           sequence   Nucleotide sequence filename and optional
                                      format, or reference (input USA)
       -paramfile          infile     Vienna RNA parameters file (optional)
       -temperature        float      [37.0] Temperature (Any numeric value)
       -[no]gu             boolean    [Y] Allow GU pairs
       -[no]closegu        boolean    [Y] Allow GU pairs at end of helices
       -[no]lp             boolean    [Y] Allow lonely pairs
       -[no]convert        boolean    [Y] Convert T to U
       -nsbases            string     Non-standard bases (Any string)
       -[no]tetraloop      boolean    [Y] Stabilizing energies for tetra-loops
       -energy             menu       [0] Rarely used option to fold sequences
                                      from the ABCD... alphabet (Values: 0 (BP); 1
                                      (Any with GC); 2 (Any with AU parameters))
       -dangles            menu       [1] Method (Values: 0 (Ignore); 1 (Only
                                      unpaired bases for just one dangling end); 2
                                      (Always use dangling energies); 3 (Allow
                                      coaxial stacking of adjacent helices))
       -folding            menu       [m] Method (Values: m (Minimum energy); pv
                                      (Partition function); mp (Both))
       -alphabet           string     [AUGC] Find sequences using only these bases
                                      (Any string)
       -final              float      [0.0] Stopping value (Any numeric value)
       -repeats            integer    [0] Number of times to search for the same
                                      structure (Integer 0 or more)
       -succeed            boolean    [N] The original RNAinverse uses a negative
                                      repeat for this
       -showfails          boolean    [N] Show information for unsuccessful
                                      searches

       Associated qualifiers:

       "-sequence" associated qualifiers
       -sbegin             integer    Start of the sequence to be used
       -send               integer    End of the sequence to be used
       -sreverse           boolean    Reverse (if DNA)
       -sask               boolean    Ask for begin/end/reverse
       -snucleotide        boolean    Sequence is nucleotide
       -sprotein           boolean    Sequence is protein
       -slower             boolean    Make lower case
       -supper             boolean    Make upper case
       -scircular          boolean    Sequence is circular
       -squick             boolean    Read id and sequence only
       -sformat            string     Input sequence format
       -iquery             string     Input query fields or ID list
       -ioffset            integer    Input start position offset
       -sdbname            string     Database name
       -sid                string     Entryname
       -ufo                string     UFO features
       -fformat            string     Features format
       -fopenfile          string     Features file name

       "-outfile" associated qualifiers
       -odirectory2        string     Output directory

       General qualifiers:
       -auto               boolean    Turn off prompts
       -stdout             boolean    Write first file to standard output
       -filter             boolean    Read first file from standard input, write
                                      first file to standard output
       -options            boolean    Prompt for standard and additional values
       -debug              boolean    Write debug output to program.dbg
       -verbose            boolean    Report some/full command line options
       -help               boolean    Report command line options and exit. More
                                      information on associated and general
                                      qualifiers can be found with -help -verbose
       -warning            boolean    Report warnings
       -error              boolean    Report errors
       -fatal              boolean    Report fatal errors
       -die                boolean    Report dying program messages
       -version            boolean    Report version number and exit

Qualifier | Type | Description | Allowed values | Default
--- | --- | --- | --- | ---
Standard (Mandatory) qualifiers
[-structuresfile] (Parameter 1) | infile | Vienna RNA structures file | Input file | Required
[-outfile] (Parameter 2) | outfile | Vienna RNAfold output file | Output file | <*>.ovrnainverse
Additional (Optional) qualifiers
(none)
Advanced (Unprompted) qualifiers
-sequence | sequence | Nucleotide sequence filename and optional format, or reference (input USA) | Readable sequence | Required
-paramfile | infile | Vienna RNA parameters file (optional) | Input file | Required
-temperature | float | Temperature | Any numeric value | 37.0
-[no]gu | boolean | Allow GU pairs | Boolean value Yes/No | Yes
-[no]closegu | boolean | Allow GU pairs at end of helices | Boolean value Yes/No | Yes
-[no]lp | boolean | Allow lonely pairs | Boolean value Yes/No | Yes
-[no]convert | boolean | Convert T to U | Boolean value Yes/No | Yes
-nsbases | string | Non-standard bases | Any string |
-[no]tetraloop | boolean | Stabilizing energies for tetra-loops | Boolean value Yes/No | Yes
-energy | list | Rarely used option to fold sequences from the ABCD... alphabet |
0 | (BP)
1 | (Any with GC)
2 | (Any with AU parameters)
| 0
-dangles | list | Method |
0 | (Ignore)
1 | (Only unpaired bases for just one dangling end)
2 | (Always use dangling energies)
3 | (Allow coaxial stacking of adjacent helices)
| 1
-folding | list | Method |
m | (Minimum energy)
pv | (Partition function)
mp | (Both)
| m
-alphabet | string | Find sequences using only these bases | Any string | AUGC
-final | float | Stopping value | Any numeric value | 0.0
-repeats | integer | Number of times to search for the same structure | Integer 0 or more | 0
-succeed | boolean | The original RNAinverse uses a negative repeat for this | Boolean value Yes/No | No
-showfails | boolean | Show information for unsuccessful searches | Boolean value Yes/No | No
Associated qualifiers
"-sequence" associated sequence qualifiers
-sbegin | integer | Start of the sequence to be used | Any integer value | 0
-send | integer | End of the sequence to be used | Any integer value | 0
-sreverse | boolean | Reverse (if DNA) | Boolean value Yes/No | N
-sask | boolean | Ask for begin/end/reverse | Boolean value Yes/No | N
-snucleotide | boolean | Sequence is nucleotide | Boolean value Yes/No | N
-sprotein | boolean | Sequence is protein | Boolean value Yes/No | N
-slower | boolean | Make lower case | Boolean value Yes/No | N
-supper | boolean | Make upper case | Boolean value Yes/No | N
-scircular | boolean | Sequence is circular | Boolean value Yes/No | N
-squick | boolean | Read id and sequence only | Boolean value Yes/No | N
-sformat | string | Input sequence format | Any string |
-iquery | string | Input query fields or ID list | Any string |
-ioffset | integer | Input start position offset | Any integer value | 0
-sdbname | string | Database name | Any string |
-sid | string | Entryname | Any string |
-ufo | string | UFO features | Any string |
-fformat | string | Features format | Any string |
-fopenfile | string | Features file name | Any string |
"-outfile" associated outfile qualifiers
-odirectory2 -odirectory_outfile | string | Output directory | Any string |
General qualifiers
-auto | boolean | Turn off prompts | Boolean value Yes/No | N
-stdout | boolean | Write first file to standard output | Boolean value Yes/No | N
-filter | boolean | Read first file from standard input, write first file to standard output | Boolean value Yes/No | N
-options | boolean | Prompt for standard and additional values | Boolean value Yes/No | N
-debug | boolean | Write debug output to program.dbg | Boolean value Yes/No | N
-verbose | boolean | Report some/full command line options | Boolean value Yes/No | Y
-help | boolean | Report command line options and exit. More information on associated and general qualifiers can be found with -help -verbose | Boolean value Yes/No | N
-warning | boolean | Report warnings | Boolean value Yes/No | Y
-error | boolean | Report errors | Boolean value Yes/No | Y
-fatal | boolean | Report fatal errors | Boolean value Yes/No | Y
-die | boolean | Report dying program messages | Boolean value Yes/No | Y
-version | boolean | Report version number and exit | Boolean value Yes/No | N

## Input file format

ovrnainverse reads any normal sequence USAs.

### Input files for usage example

### File: rna3.fold

    (((((((..((((........)))).(((((.......))))).....(((((.......))))))))))))....

## Output file format

ovrnainverse outputs a graph to the specified graphics device. outputs a report format file. The default format is ...

### Output files for usage example

### File: rna3.ovrnainverse

    CGGGUGUCCGGGCUGAUGCGUGCUCCGCCGUAACCGGGACGGCAAGUUUAGUCCUACAUCGACUAACACUCGACCG   32
    CUAUGAUGAUGUAAACGAUACUACACUGGGCCGCUUCCGUCCACAUUGCGACCUUGCAUUGGUUGAUCGUGGUUAC   30
    GUUCGGAAUCGAGCAUAUACACUCGUUAGCCAUUGAGCGGCUGCAACCGUGCACUUUUCCUGUACUCCGGACCGAA   15

### Output files for usage example 2

### File: rna3.ovrnainverse

    UUAAACCACGUGUAGUAGGAAGCGCAUCAUUAUGAACAGAUGAGGGUAAGAACGGGGUGAGUUUUGGUUUAGAAAU   26
    CUUUCAACGCUUGAUCCUUCCCAAGACACCAAAUCUCGUGGUGGCUGCGUCGGUUUCCCUUCGAUUUGAGAGUGAA   33
    UUUACGGUCAGACACGGAUUAGUCUAAGCCGAUCUCCGCGGUUAACAACGGCCUAAACCUGGUCGCCGUAGAAACA   17

## Data files

For details of Vienna RNA file formats, see the original documentation http://www.tbi.univie.ac.at/~ivo/RNA/

## Notes

None.

## References

None.

## Warnings

None.

## Diagnostic Error Messages

None.

## Exit status

It always exits with status 0.

## Known bugs

None.

## See also

Program name | Description
--- | ---
banana | Plot bending and curvature data for B-DNA
btwisted | Calculate the twisting in a B-DNA sequence
einverted | Find inverted repeats in nucleotide sequences
ovrnaalifold | Calculate secondary structures for a set of aligned RNAs
ovrnaalifoldpf | Calculate secondary structures for a set of aligned RNAs (partition)
ovrnacofold | Calculate secondary structures of RNA dimers
ovrnacofoldconc | Calculate secondary structures of RNA dimers (concentrations)
ovrnacofoldpf | Calculate secondary structures of RNA dimers (partitioning)
ovrnadistance | Calculate distances between RNA secondary structures
ovrnaduplex | Predict RNA duplex (hybridization) sites and structure
ovrnaeval | Calculate energy of RNA sequences with a given secondary structure
ovrnaevalpair | Calculate energy of RNA sequences on given secondary structure
ovrnafold | Calculate min. energy RNA structure / pair probabilities (partition)
ovrnafoldpf | Calculate min. energy RNA structure / pair probabilities
ovrnaheat | Calculate specific heat of RNA melting
ovrnalfold | Calculate locally stable secondary structures of RNAs
ovrnaplot | Draw RNA secondary structures
ovrnasubopt | Calculate suboptimal secondary structure of RNA
sirna | Find siRNA duplexes in mRNA
vrna2dfold | Calculate RNA structures and samples of k,l neighbourhoods
vrnaaliduplex | RNA duplex calculation for two sequence alignments
vrnaalifold | Calculate secondary structures for a set of aligned RNAs
vrnaalifoldpf | Calculate secondary structures for a set of aligned RNAs (partition)
vrnacofold | Calculate secondary structures of RNA dimers
vrnacofoldconc | Calculate secondary structures of RNA dimers (concentrations)
vrnacofoldpf | Calculate secondary structures of RNA dimers (partitioning)
vrnadistance | Calculate distances between RNA secondary structures
vrnaduplex | Predict RNA duplex (hybridization) sites and structure
vrnaeval | Calculate energy of RNA sequences with a given secondary structure
vrnaevalpair | Calculate energy of RNA sequences on given secondary structure
vrnafold | Calculate min. energy RNA secondary structures and pair probabilities
vrnafoldpf | Calculate min. energy RNA structures / pair probabilities (partition)
vrnaheat | Calculate specific heat of RNA melting
vrnainverse | Find RNA sequences with a given secondary structure
vrnalalifoldpf | Calculate secondary structures for a set of aligned RNAs (partition)
vrnalfold | Calculate locally stable secondary structures of RNAs
vrnalfoldz | Calculate locally stable secondary structures of RNAs plus zscore
vrnapkplex | Calculate RNA structures plus pseudoknots
vrnaplfold | Compute avg. pair probabilities for local base pairs in RNA sequences
vrnaplot | Draw RNA secondary structures
vrnasubopt | Calculate suboptimal secondary structures of RNAs

## Author(s)

This program is an EMBOSS conversion of a program written by Ivo Hofacker as part of his VIENNA package.

Please report all bugs to the EMBOSS bug team (emboss-bug © emboss.open-bio.org) not to the original author.

## History

Converted (October 2005) by Alan Bleasby

## Target users

This program is intended to be used by everyone and everything, from naive users to embedded scripts.

## Comments